#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>

int main( int argc, char **argv ) 
{
  if( argc < 2 )
  {
    printf( "No input file. Aborting... \n" );
    return 0;
  }
   
  FILE* binaryFile;
  FILE* csvFile;

  char fileName[255];
  memset( fileName, 0, 255 );
  strcpy( fileName, argv[1] );
  char ext[] = ".csv";
  strcpy( fileName + strlen( argv[1] ), ext );
  
  binaryFile = fopen( argv[1], "rb" );
  csvFile    = fopen( fileName, "w" );
  
  long lastStamp = 0;
  char buff[20];
  do
  {
    long timeStamp = 0;
    double value = 0;
    
    fread( (char*)&timeStamp, sizeof( long ), 1, binaryFile );
    if( timeStamp <= 0 )
    {
      break;
    }
   
    time_t time_val = ( timeStamp - 62135596800000 ) / 1000;
    
    long tm1000 = ( timeStamp / 1000 ) * 1000;
    long msecs =  ( timeStamp - tm1000 ); 
    
    fread( (char*)&value, 8, 1, binaryFile );
    if( lastStamp == 0 )
    {
      lastStamp = timeStamp;
    }      
    
    long diff = timeStamp - lastStamp;
    
    strftime( buff, 20, "%d-%m-%Y %H:%M:%S", gmtime( &time_val ) );
    fprintf( csvFile, "%s.%i;%i;%f \n", buff, msecs, diff, value );
    
  }while( !feof( binaryFile ) );

  fclose( binaryFile );
  fclose( csvFile );

  return 0;
}
